/**
 * DevExtreme (esm/renovation/ui/scroll_view/scroll_view.j.js)
 * Version: 21.1.2 (build 21124-0324)
 * Build date: Tue May 04 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import registerComponent from "../../../core/component_registrator";
import BaseComponent from "../../component_wrapper/component";
import {
    ScrollView as ScrollViewComponent
} from "./scroll_view";
export default class ScrollView extends BaseComponent {
    update() {
        return this.viewRef.update()
    }
    release() {
        return this.viewRef.release()
    }
    refresh() {
        return this.viewRef.refresh()
    }
    content() {
        return this._toPublicElement(this.viewRef.content())
    }
    scrollBy(distance) {
        return this.viewRef.scrollBy(distance)
    }
    scrollTo(targetLocation) {
        return this.viewRef.scrollTo(targetLocation)
    }
    scrollToElement(element) {
        return this.viewRef.scrollToElement(this._patchElementParam(element))
    }
    scrollHeight() {
        return this.viewRef.scrollHeight()
    }
    scrollWidth() {
        return this.viewRef.scrollWidth()
    }
    scrollOffset() {
        return this.viewRef.scrollOffset()
    }
    scrollTop() {
        return this.viewRef.scrollTop()
    }
    scrollLeft() {
        return this.viewRef.scrollLeft()
    }
    clientHeight() {
        return this.viewRef.clientHeight()
    }
    clientWidth() {
        return this.viewRef.clientWidth()
    }
    _getActionConfigs() {
        return {
            onScroll: {},
            onUpdated: {},
            onPullDown: {},
            onReachBottom: {},
            onStart: {},
            onEnd: {},
            onBounce: {},
            onStop: {}
        }
    }
    get _propsInfo() {
        return {
            twoWay: [],
            allowNull: [],
            elements: [],
            templates: [],
            props: ["useNative", "direction", "showScrollbar", "bounceEnabled", "scrollByContent", "scrollByThumb", "updateManually", "classes", "pullDownEnabled", "reachBottomEnabled", "onScroll", "onUpdated", "onPullDown", "onReachBottom", "pullingDownText", "pulledDownText", "refreshingText", "reachBottomText", "aria", "disabled", "height", "rtlEnabled", "visible", "width", "useSimulatedScrollbar", "inertiaEnabled", "useKeyboard", "onStart", "onEnd", "onBounce", "onStop"]
        }
    }
    get _viewComponent() {
        return ScrollViewComponent
    }
}
registerComponent("dxScrollView", ScrollView);
