/**
* DevExtreme (events/index.d.ts)
* Version: 21.1.2 (build 21124-0324)
* Build date: Tue May 04 2021
*
* Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    DxElement
} from '../core/element';

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EventExtension { }
/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface EventType { }
/**
 * 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type DxEvent = {} extends EventType ? EventObject : EventType;

export interface InitializedEventInfo<T> {
    readonly component?: T;
    readonly element?: DxElement;
}

export interface EventInfo<T> {
    readonly component: T;
    readonly element: DxElement;
    readonly model?: any;
}

export interface NativeEventInfo<T> {
    readonly component: T;
    readonly element: DxElement;
    readonly model?: any;
    readonly event?: DxEvent;
}

export interface ChangedOptionInfo {
    readonly name: string;
    readonly fullName: string;
    readonly value?: any;
    readonly previousValue?: any;
}

/**
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export interface ItemInfo {
    readonly itemData?: any;
    readonly itemElement: DxElement;
    readonly itemIndex: number;
}

export interface Cancelable {
    cancel?: boolean;
}

/**
 * @deprecated
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type dxEvent = EventObject;

/**
 * 
 */
export class EventObject {
    /**
     * 
     */
    currentTarget: Element;
    /**
     * 
     */
    data: any;
    /**
     * 
     */
    delegateTarget: Element;
    /**
     * 
     */
    target: Element;
    /**
     * 
     */
    isDefaultPrevented(): boolean;
    /**
     * 
     */
    isImmediatePropagationStopped(): boolean;
    /**
     * 
     */
    isPropagationStopped(): boolean;
    /**
     * 
     */
    preventDefault(): void;
    /**
     * 
     */
    stopImmediatePropagation(): void;
    /**
     * 
     */
    stopPropagation(): void;
}

/**
 * 
 * @deprecated 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export type event = DxEvent;

/**
 * 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export function eventsHandler(event: DxEvent, extraParameters: any): boolean;

/**
 * Detaches all handlers from the specified elements.
 */
export function off(element: Element | Array<Element>): void;

/**
 * Detaches all handlers of the specified event from the specified elements.
 */
export function off(element: Element | Array<Element>, eventName: string): void;

/**
 * Detaches an event handler from the specified elements.
 */
export function off(element: Element | Array<Element>, eventName: string, handler: Function): void;

/**
 * Detaches all event handlers of the specified type attached using the on(element, eventName, selector, data, handler) or on(element, eventName, selector, handler) method.
 */
export function off(element: Element | Array<Element>, eventName: string, selector: string): void;

/**
 * Detaches the specified event handler attached using the on(element, eventName, selector, data, handler) or on(element, eventName, selector, handler) method.
 */
export function off(element: Element | Array<Element>, eventName: string, selector: string, handler: Function): void;

/**
 * Attaches an event handler to the specified elements. Allows you to pass custom data to the handler.
 */
export function on(element: Element | Array<Element>, eventName: string, data: any, handler: Function): void;

/**
 * Attaches an event handler to the specified elements.
 */
export function on(element: Element | Array<Element>, eventName: string, handler: Function): void;

/**
 * Attaches an event handler to the specified elements&apos; descendants. Allows you to pass custom data to the handler.
 */
export function on(element: Element | Array<Element>, eventName: string, selector: string, data: any, handler: Function): void;

/**
 * Attaches an event handler to the specified elements&apos; descendants.
 */
export function on(element: Element | Array<Element>, eventName: string, selector: string, handler: Function): void;

/**
 * Attaches an event handler that is executed only once to the specified elements. Allows you to pass custom data to the handler.
 */
export function one(element: Element | Array<Element>, eventName: string, data: any, handler: Function): void;

/**
 * Attaches an event handler that is executed only once to the specified elements.
 */
export function one(element: Element | Array<Element>, eventName: string, handler: Function): void;

/**
 * Attaches an event handler that is executed only once to the specified elements&apos; descendants. Allows you to pass custom data to the handler.
 */
export function one(element: Element | Array<Element>, eventName: string, selector: string, data: any, handler: Function): void;

/**
 * Attaches an event handler that is executed only once to the specified elements&apos; descendants.
 */
export function one(element: Element | Array<Element>, eventName: string, selector: string, handler: Function): void;

/**
 * Triggers an event for the specified elements.
 */
export function trigger(element: Element | Array<Element>, event: string | DxEvent): void;

/**
 * Triggers an event for the specified elements. Allows you to pass custom parameters to event handlers.
 */
export function trigger(element: Element | Array<Element>, event: string | DxEvent, extraParameters: any): void;

/**
 * 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export function triggerHandler(element: Element | Array<Element>, event: string | DxEvent): void;

/**
 * 
 * @deprecated Warning! This type is used for internal purposes. Do not import it directly.
 */
export function triggerHandler(element: Element | Array<Element>, event: string | DxEvent, extraParameters: any): void;
